using System;
using Antlr.Runtime;
using Antlr.Runtime.Tree;
using Microsoft.Scripting;
using Microsoft.Scripting.Ast;
using Microsoft.Scripting.Hosting.Shell;
using Microsoft.Scripting.Runtime;
using MyL.Parser.AST;
using MyL.Runtime;

namespace MyL {

	public class MyLLanguageContext : LanguageContext {

		public MyLLanguageContext(ScriptDomainManager manager)
			: base(manager) {
			Binder = new MyLBinder(manager);
		}

		public override LambdaExpression ParseSourceCode(CompilerContext context) {
			LambdaBuilder lb;
			LambdaExpression le;
			CommonTokenStream tokenStream;
			CommonTree t;
			MyLLexer lexer;
			MyLParser parser;
			MyLParser.program_return r;
			CommonTreeNodeStream n;
			MyLTree w;
			MyLStatement s;
			Expression e;

			le = null;
			try {
				MyLSymbolTable.Initialize();
				lexer = new MyLLexer(new ANTLRStringStream(context.SourceUnit.GetCode()));
				tokenStream = new CommonTokenStream(lexer);
				parser = new MyLParser(tokenStream);
				r = parser.program();
				t = (CommonTree)r.Tree;
				n = new CommonTreeNodeStream(t);
				w = new MyLTree(n);
				s = w.program().result;
				e = s.Generate(this);
				lb =  MyLSymbolTable.GlobalScope.FinishScope(e);
				le = lb.MakeLambda();
			} catch (Exception ex) {
				Console.WriteLine(ex.Message);
			}

			return le;
		}

	}
}
