﻿using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLAssign : MyLExpression {

        private readonly MyLExpression _lvalue;
        private readonly MyLExpression _rvalue;

        public MyLAssign(SourceSpan span, MyLExpression lvalue, MyLExpression rvalue)
            : base(span) {
            _lvalue = lvalue;
            _rvalue = rvalue;
        }

        protected internal override Expression Generate(MyLLanguageContext context) {
            return _lvalue.GenerateAssign(_rvalue.Generate(context));
        }
    }

}
