using Microsoft.Scripting;
using Microsoft.Scripting.Ast;
using Microsoft.Scripting.Runtime;

namespace MyL.Parser.AST {

	class MyLBinary :MyLExpression {

			private readonly int _op;
			private readonly MyLExpression _left;
			private readonly MyLExpression _right;

			public MyLBinary(SourceSpan span, int op, MyLExpression left, MyLExpression right)
				: base(span) {
				_op = op;
				_left = left;
				_right = right;
			}

			protected internal override Expression Generate (MyLLanguageContext context) {
				Expression left = _left.Generate(context);
				Expression right = _right.Generate(context);

				//ExpressionType op;
				//switch (_op) {
				//    case MyLLexer.PLUS: op = ExpressionType.Add; break;
				//    case MyLLexer.MINUS: op = ExpressionType.Subtract; break;
				//    case MyLLexer.MULTIPLY: op = ExpressionType.Multiply; break;
				//    case MyLLexer.DIVIDE: op = ExpressionType.Divide; break;
				//    default:
				//        throw new System.InvalidOperationException();
				//}
				//if (left.Type.Name == "Double" && right.Type.Name == "Double") {
				//    return Expression.MakeBinary(op, left, right);
				//} else {
				//    return Expression.Action.Operator(context.Binder, Operators.Add, typeof(object), Expression.CodeContext(), left, right);
				//}
				Operators op;
				switch (_op) {
					case MyLLexer.PLUS: op = Operators.Add; break;
					case MyLLexer.MINUS: op = Operators.Subtract; break;
					case MyLLexer.MULTIPLY: op = Operators.Multiply; break;
					case MyLLexer.DIVIDE: op = Operators.Divide; break;
					default:
						throw new System.InvalidOperationException();
				}
				return Expression.Action.Operator(context.Binder, op, typeof(object), Expression.CodeContext(), left, right);
			}
		}

	}
