﻿using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLIdentifier : MyLExpression{

        private readonly string _name;

		public MyLIdentifier(SourceSpan span, string name)
            : base(span) {

            _name = name;
        }

        protected internal override Expression Generate(MyLLanguageContext context) {
			Expression v;
            
			v = GetVariable();
            return v;
        }

        protected internal override Expression GenerateAssign(Expression right) {
			Expression v;
			
			v = GetVariable();
            return Expression.Assign(v, Expression.ConvertHelper(right, v.Type));

		}

		private Expression GetVariable () {
			Expression v;

			v = MyLSymbolTable.LookupName(_name);
            if (v == null) {
				v = MyLSymbolTable.GetOrMakeGlobal(_name);
            }
            return v;
        }
	}
}
