﻿using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser.AST {

	class MyLUnary : MyLExpression {

		private readonly int _op;
		private readonly MyLExpression _arg;

		public MyLUnary(SourceSpan span, int op, MyLExpression arg)
			: base(span) {
			_op = op;
			_arg = arg;
		}

		protected internal override Expression Generate (MyLLanguageContext context) {
			Expression arg = _arg.Generate(context);

			ExpressionType op;
			switch (_op) {
				case MyLLexer.UNARY_PLUS:
					op = ExpressionType.UnaryPlus;
                    break;
				case MyLLexer.UNARY_MINUS:
					op = ExpressionType.Negate; 
                    break;
				default:
					throw new System.InvalidOperationException();
			}
			return Expression.MakeUnary(op, arg, typeof(object));
		}
	}

}
