﻿using System;
using System.Collections.Generic;
using Microsoft.Scripting;
using Microsoft.Scripting.Ast;

namespace MyL.Parser {

	class MyLScope {

		private Dictionary<string, Expression> _variables = new Dictionary<string, Expression>();

		private LambdaBuilder _block;
		public LambdaBuilder Block {
			get { return _block; }
		}

		public MyLScope(string name) {

			_block = Utils.Lambda(typeof(object), name, Annotations.Empty);
		}

		public Expression GetOrMakeGlobal (string name, Type type) {
			Expression v;

			if (!_variables.TryGetValue(name, out v)) {
				v = _block.CreateGlobalVariable(SymbolTable.StringToId(name), type);
				_variables[name] = v;
			}
			return v;
		}

		public Expression LookupName (string name) {
			Expression v;

			_variables.TryGetValue(name, out v);
			return v;
		}

		public LambdaBuilder FinishScope (Expression body) {

			_block.Body = body;
			return _block;
		}
	}
}
